////////////////////////////////////////////////////////////////////////////////
///
///		Title		: MiniMap Interface Haeder File
///
///		Copyright (c) 2006, NHN Co., Ltd. ALL RIGHTS RESERVED
///
///		Team		: Desktop Service Development
///
////////////////////////////////////////////////////////////////////////////////
#pragma once
#include "ComponentUI.h"
#include "NPCommonUI.h"

interface IMimicListener;
/**
* @ingroup 	Common UI	
* @brief 	mimic interface
* @date		11/29/2006
* @author	telltale
* @remark	
*/
interface IMimic
{
public:
	virtual ~IMimic() {	 }

	static const DWORD NMM_STATE_NORMAL		= 0x1;
	static const DWORD NMM_STATE_DRAGGING	= 0x2;

	/**
	* @brief 	draw target window
	* @param	hDC	handle of the MiniMap DC
	* @param	pRect the rect of the BMP IMG RECT int the MiniMap
	* @return	none
	*/
	virtual void DrawMinic(HDC hDCMM, LPCRECT pRcMM) = 0;
	/**
	* @brief 	this function retrieves the parameters of a scroll bar
	* @param	fnBar	specifies the type of scroll (SB_HORZ, SB_VERT)
	* @param	lpScrollInfo	pointer a SCROLLINFO
	* @return	If function succeeds, the return value is TRUE
	*/
	virtual BOOL GetScrollInfo(int fnBar, IN OUT LPSCROLLINFO lpScrollInfo) = 0;
	/**
	* @brief 	this function sets the parameters of a scroll bar
	* @param	fnBar	specifies the type of scroll (SB_HORZ, SB_VERT)
	* @param	lpScrollInfo	pointer a SCROLLINFO
	* @param	dwState	{kr}  ̴ϸ . ex) , 巡 {/kr} 
	* @return	the return value is the current position of scroll box
	*/
	virtual int SetScrollInfo(int fnBar, LPSCROLLINFO lpScrollInfo, DWORD dwState = NMM_STATE_NORMAL) = 0;
	
	/**
	* @brief 	add mimic listener
	* @param	pListener	mimic listener
	* @return	none
	*/
	virtual void AddMimicListener(IMimicListener* pListener) = 0;
	/**
	* @brief 	remove mimic listener
	* @param	pListener	mimic listener
	* @return	none
	*/
	virtual void RemoveMimicListener(IMimicListener* pListener) = 0;
};

/**
* @ingroup 	Common UI	
* @brief 	
* @date		11/29/2006
* @author	telltale
* @remark	
*/
interface IMimicListener
{
public:
	virtual ~IMimicListener() {  }
	/**
	* @brief 	whenever change mimic property(size, scrollinfo etc)
	*/
	virtual void OnChangeMimic() = 0;
	/**
	* @brief 	whenever paint mimic
	*/
	virtual void OnPaintMimic(BOOL bRedraw = FALSE) = 0;
};

interface IPanelUI;
class CNMiniMapCtrl;

/**
* \group NMiniMap
* \brief {kr} ̴ϸ UI ӹ޾ ϴ ̽ {/kr}
* \date 2006-12-07
* \author hhd2002
* \remark {kr}  г UI ԵǸ,    ׸. {/kr}
*/
interface NPCOMMONUI_API INMiniMapCtrlUI : public IComponentUI
{
	DECLARE_RTTI

public:
	virtual ~INMiniMapCtrlUI() {  }
	/**
	* \brief 	{kr}  г ü ´. {/kr}
	* \return 
	*/
	virtual IPanelUI* GetWPanelUI() = 0;
	/**
	* \brief 	{kr} ̴ϸ   ׸. {/kr}
	* \param hDC {kr} ̴ϸ DC {/kr} 
	* \param pMM {kr} ̴ϸ  {/kr} 
	*/
	virtual void DrawBackGnd(HDC hDC, CNMiniMapCtrl* pMM) = 0;
};